Kea: isc::yang::TranslatorHosts Class Reference

| Kea 3.2.0-git

isc::yang::TranslatorHosts Class Reference

A translator class for converting host reservations list between YANG and JSON. More...

`#include <translator_host.h>`

Inheritance diagram for isc::yang::TranslatorHosts:
[legend]

## Public Member Functions
| TranslatorHosts (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorHosts ()=default
| Destructor.
isc::data::ElementPtr | getHosts (libyang::DataNode const &data_node)
| Translate host reservations from YANG to JSON.
isc::data::ElementPtr | getHostsFromAbsoluteXpath (std::string const &xpath)
| Translate host reservations from YANG to JSON.
void | setHosts (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set (address) host reservations from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorHost
| TranslatorHost (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorHost ()=default
| Destructor.
isc::data::ElementPtr | getHost (libyang::DataNode const &data_node)
| Translate a host reservation from YANG to JSON.
isc::data::ElementPtr | getHostFromAbsoluteXpath (std::string const &xpath)
| Translate a host reservation from YANG to JSON.
void | setHost (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set host reservation from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorOptionDataList
| TranslatorOptionDataList (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionDataList ()=default
| Destructor.
isc::data::ConstElementPtr | getOptionDataList (libyang::DataNode const &data_node)
| Translate option data list from YANG to JSON.
isc::data::ConstElementPtr | getOptionDataListFromAbsoluteXpath (std::string const &xpath)
| Translate option data list from YANG to JSON.
void | setOptionDataList (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data list from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorOptionData
| TranslatorOptionData (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionData ()=default
| Destructor.
isc::data::ElementPtr | getOptionData (libyang::DataNode const &data_node)
| Translate an option data from YANG to JSON.
isc::data::ElementPtr | getOptionDataFromAbsoluteXpath (std::string const &xpath)
| Translate an option data from YANG to JSON.
void | setOptionData (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data from JSON to YANG.
Public Member Functions inherited from isc::yang::Translator
| Translator (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~Translator ()=default
| Destructor.
template<typename T>
void | checkAndGet (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {xpath} key.
void | checkAndGetAndJsonifyLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, const std::string &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node, converts it from string to JSON and stores it in the specified storage.
template<typename T>
void | checkAndGetDiverging (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &key, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {key} key.
void | checkAndGetDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndGetLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndSetDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeafList (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath as a leaf-list.
void | checkAndSetUserContext (isc::data::ConstElementPtr const &from, std::string const &xpath)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndStringifyAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | deleteItem (const std::string &xpath)
| Delete basic value from YANG.
libyang::DataNode | findXPath (std::string const &xpath) const
| Retrieves a YANG data node by xpath.
template<typename functor_t>
void | forAll (std::string const &xpath, functor_t f) const
| Run a function for a node and all its children.
std::optional< libyang::DataNode > | getData (std::string const &xpath) const
| Get a YANG data node found at the given absolute xpath.
isc::data::ElementPtr | getItem (libyang::DataNode const &data_node, std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given xpath that is relative to the given source node.
isc::data::ElementPtr | getItemFromAbsoluteXpath (std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given absolute xpath.
template<typename T>
isc::data::ElementPtr | getList (libyang::DataNode const &data_node, std::string const &xpath, T &t, isc::data::ElementPtr(T::*f)(libyang::DataNode const &)) const
| Retrieve a list as ElementPtr from sysrepo from a certain xpath.
void | getMandatoryDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by one name from the given parent YANG container node and stores it in the specified storage under a different name.
void | getMandatoryLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
bool | schemaNodeExists (std::string const &xpath) const
| Checks whether a YANG node exists in the schema.
void | setItem (const std::string &xpath, isc::data::ConstElementPtr const elem, libyang::LeafBaseType const type)
| Translate and set basic value from JSON to YANG.
void | setMandatoryDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | setMandatoryLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.

## Protected Member Functions
void | setHostsKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setHosts for kea-dhcp[46].
Protected Member Functions inherited from isc::yang::TranslatorHost
isc::data::ElementPtr | getHostKea (libyang::DataNode const &data_node)
| getHost for kea-dhcp[46]-server models.
void | setHostKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setHost for kea-dhcp[46]-server models.
Protected Member Functions inherited from isc::yang::TranslatorOptionDataList
isc::data::ConstElementPtr | getOptionDataListKea (libyang::DataNode const &data_node)
| getOptionDataList for kea-dhcp[46].
void | setOptionDataListKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionDataList for kea-dhcp[46].
Protected Member Functions inherited from isc::yang::TranslatorOptionData
isc::data::ElementPtr | getOptionDataKea (libyang::DataNode const &data_node)
| getOptionData JSON for kea-dhcp[46].
void | setOptionDataKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionData for kea-dhcp[46].

## Additional Inherited Members
Static Public Member Functions inherited from isc::yang::Translator
static isc::data::ElementPtr | translateFromYang (std::optional< libyang::DataNode > data_node)
| Translate basic value from the given YANG data node to JSON element.
static std::optional< std::string > | translateToYang (isc::data::ConstElementPtr const &elem, libyang::LeafBaseType const type)
| Translate basic value from JSON to YANG.
Protected Types inherited from isc::yang::Translator
using | Deserializer
| Maps YANG types to functions that transform a YANG type into an ElementPtr.
using | Serializer
| Maps YANG types to functions that transform the string representation of an Element into a string that can be passed into Session::setItem().
Static Protected Member Functions inherited from isc::yang::Translator
static std::string | decode64 (std::string const &input)
| Decode a YANG element of binary type to a string that can be stored in an Element::string JSON.
static std::string | encode64 (std::string const &input)
| Encode a string such that it can be stored in a YANG element of binary type.
static Deserializer | initializeDeserializer ()
| Initializes the deserializer which is used to translate a YANG node to an ElementPtr.
static Serializer | initializeSerializer ()
| Initializes the serializer which is used to translate the string value of an Element to a string that can be passed into Session::setItem().
Protected Attributes inherited from isc::yang::Translator
std::string | model_
| The model.
sysrepo::Session | session_
| The sysrepo session.

## Detailed Description

A translator class for converting host reservations list between YANG and JSON.

Currently supports the following models:

- kea-dhcp4-server
- kea-dhcp6-server

The ietf-dhcpv6-server model is not yet supported.

Definition at line 176 of file translator_host.h.

## Constructor & Destructor Documentation

## ◆ TranslatorHosts()

isc::yang::TranslatorHosts::TranslatorHosts | ( | sysrepo::Session | session,
|  | const std::string & | model )

Constructor.

Parameters

  session | Sysrepo session.
  model | Model name.

Definition at line 136 of file translator_host.cc.

References isc::yang::TranslatorHost::TranslatorHost().

Referenced by isc::yang::TranslatorSubnet::TranslatorSubnet().

Here is the call graph for this function:

## ◆ ~TranslatorHosts()

virtual isc::yang::TranslatorHosts::~TranslatorHosts | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getHosts()

ElementPtr isc::yang::TranslatorHosts::getHosts | ( | libyang::DataNode const & | data_node | ) |

Translate host reservations from YANG to JSON.

Parameters

  data_node | the YANG node representing the list of host reservations

Returns
  the JSON representation of the list of host reservations

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 144 of file translator_host.cc.

References isc::yang::TranslatorHost::getHost(), and isc::yang::Translator::getList().

Referenced by getHostsFromAbsoluteXpath(), isc::yang::TranslatorConfig::getServerKeaDhcpCommon(), and isc::yang::TranslatorSubnet::getSubnetKea().

Here is the call graph for this function:

## ◆ getHostsFromAbsoluteXpath()

ElementPtr isc::yang::TranslatorHosts::getHostsFromAbsoluteXpath | ( | std::string const & | xpath | ) |

Translate host reservations from YANG to JSON.

Note
  This is a computationally expensive operation that makes a lookup in the sysrepo datastore by calling Session::getData(). It should be used sparingly in production code, mainly to get an initial data node to work with. It may be used at will in unit tests. Use getHosts(libyang::DataNode) as a scalable alternative.

Parameters

  xpath | The xpath of the host reservation list.

Returns
  JSON representation of the host reservation list.

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 150 of file translator_host.cc.

References isc::yang::Translator::findXPath(), and getHosts().

Here is the call graph for this function:

## ◆ setHosts()

void isc::yang::TranslatorHosts::setHosts | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )

Translate and set (address) host reservations from JSON to YANG.

Parameters

  xpath | The xpath of the host reservation list.
  elem | The JSON element.

Definition at line 159 of file translator_host.cc.

References isc_throw, isc::yang::Translator::model_, setHostsKea(), and isc::Exception::what().

Referenced by isc::yang::TranslatorConfig::setServerKeaDhcpCommon(), and isc::yang::TranslatorSubnet::setSubnetKea().

Here is the call graph for this function:

## ◆ setHostsKea()

void isc::yang::TranslatorHosts::setHostsKea | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )
| protected

setHosts for kea-dhcp[46].

Parameters

  xpath | The xpath of the host reservation list.
  elem | The JSON element.

Exceptions

  BadValue | on host reservation without known identifier type.

Definition at line 176 of file translator_host.cc.

References isc_throw, isc::yang::Translator::model_, and isc::yang::TranslatorHost::setHost().

Referenced by setHosts().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- translator_host.h
- translator_host.cc